unit USSMaps;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, ActiveX, ExtCtrls, JPEG, ComCtrls,
  sSkinManager, XPMan;

type
  TfrmGoogleMaps = class(TForm)
    Panel1: TPanel;
    WebBrowser1: TWebBrowser;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditCidade: TEdit;
    EditUF: TEdit;
    EditRua: TEdit;
    btnLocalizar: TButton;
    btnSalvar: TButton;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    sSkinManager1: TsSkinManager;
    XPManifest1: TXPManifest;
    procedure btnLocalizarClick(Sender: TObject);
    procedure WebBrowserScreenShot(const wb: TWebBrowser; const fileName: TFileName);
    procedure btnSalvarClick(Sender: TObject);
    procedure WebBrowser1DownloadBegin(Sender: TObject);
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure WebBrowser1ProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGoogleMaps: TfrmGoogleMaps;

implementation

{$R *.dfm}

procedure TfrmGoogleMaps.btnLocalizarClick(Sender: TObject);
Var ConsultaEndereco : string;
begin
 ConsultaEndereco := 'GoogleMaps.html?Address=';
 If EditCidade.Text <> '' Then
  ConsultaEndereco := ConsultaEndereco + EditCidade.Text;
 If EditUF.Text <> '' Then
  ConsultaEndereco := ConsultaEndereco + ',' + EditUF.Text;
 If EditRua.Text <> ''  Then
  ConsultaEndereco := ConsultaEndereco + ',' + EditRua.Text;
// Caption := ConsultaEndereco;
  ConsultaEndereco:= StringReplace(ConsultaEndereco,' ','%',[rfReplaceAll]);
 Webbrowser1.Navigate( ExtractFilePath(application.ExeName) + ConsultaEndereco);
end;

procedure TfrmGoogleMaps.WebBrowserScreenShot(const wb: TWebBrowser; const fileName: TFileName);
var
  ViewObject : IViewObject;
  R : TRect;
  Bitmap : TBitmap;
begin
  if wb.Document <> nil then
  begin
    wb.Document.QueryInterface(IViewObject, ViewObject);
    if Assigned(ViewObject) then
    try
      Bitmap := TBitmap.Create;
      try
        R := Rect(0, 0, wb.Width, wb.Height);

        Bitmap.Width := wb.Width-20;
        Bitmap.Height := wb.Height;

        ViewObject.Draw(DVASPECT_CONTENT, 1, nil, nil, Application.Handle, Bitmap.Canvas.Handle, @R, nil, nil, 0);

        with TJPEGImage.Create do
        try
          Assign(Bitmap);
          SaveToFile(fileName);
        finally
          Free;
        end;
      finally
        Bitmap.Free;
      end;
    finally
      ViewObject._Release;
    end;
  end;
end;

procedure TfrmGoogleMaps.btnSalvarClick(Sender: TObject);
Var NameFile : string;
begin
   //Salva a Imagem do mapa
   NameFile:='C:\';
   If EditCidade.Text <> '' Then
      NameFile := NameFile + EditCidade.Text;
   If EditUF.Text <> '' Then
      NameFile := NameFile + '_' + EditUF.Text;
   If EditRua.Text <> ''  Then
      NameFile := NameFile + '_' + EditRua.Text;

   SaveDialog1.FileName:= NameFile+'.jpg';
   if SaveDialog1.Execute then
      WebBrowserScreenShot(WebBrowser1, SaveDialog1.FileName );

end;

procedure TfrmGoogleMaps.WebBrowser1DownloadBegin(Sender: TObject);
begin
  //Atualiza o status bar no inicio da navegao
  Statusbar1.Panels[0].Text:=' ';
  Statusbar1.Panels[0].Text:=Caption;
  Statusbar1.Panels[1].Text:='Carregando...';

end;

procedure TfrmGoogleMaps.WebBrowser1DownloadComplete(Sender: TObject);
begin
 //Atualiza o status bar no final da navegao
 Statusbar1.Panels[0].Text:='';
 Statusbar1.Panels[0].Text:=Caption;
 StatusBar1.Panels[1].Text:='Concluido';
end;

procedure TfrmGoogleMaps.WebBrowser1ProgressChange(Sender: TObject; Progress,
  ProgressMax: Integer);
begin
 //Mostra o andamento da navegao na statusbar
 if (ProgressMax > 0) then
  Begin
   Statusbar1.Panels[1].Text:='Baixando '+ inttostr(Progress)+' bytes' ;
  End;
end;

end.
